%define DATE 20030801
%define gcc_version 3.5-tree-ssa
%define gcc_release 48
%define ssa_lib /%{_lib}/ssa
%define _unpackaged_files_terminate_build 0
ExclusiveArch: i386 i686 i586 x86_64 ppc ia64
Summary: Various compilers (C, C++, Objective-C, Java, ...) (GCC SSA snapshot)
Name: gcc-ssa
Version: 3.5ssa
Release: 0.%{DATE}.%{gcc_release}
License: GPL
Group: Development/Languages
# FIXME: Replace Source0 with this.
# Source0: gcc-%{version}-%{DATE}.tar.bz2
Source0: gcc-3.5ssa-20030617.tar.bz2
Source1: libmudflap-20040803.tar.bz2
# Create with tar cvfj <FILE> --exclude CVS libmudflap depcomp
URL: http://gcc.gnu.org/projects/tree-ssa/
BuildRoot: /var/tmp/gcc-ssa-root
BuildRequires: binutils >= 2.11.90.0.8-12
BuildRequires: zlib-devel
Requires: binutils >= 2.11.90.0.8-12
Requires: glibc-devel
Requires: libgcc-ssa >= %{version}-%{release}
Prereq: /sbin/install-info
Patch09: libgcj-reverse-time-patch
Patch10: gcj-jikes-layout-patch
Patch11: gcj-miranda-method-patch
Patch12: gcj-verifier-hack-patch
Patch13: gcj-jcf-parse-patch
Patch20: libgcj-assume-exception-patch
Patch21: libgcj-disable-verifier-patch
Patch22: libgcj-gij-dashx-patch
Patch23: libgcj-optional-pr-9125-patch
Patch24: libgcj-solib-extra-files-patch
Patch25: libgcj-solib-url-patch
Patch27: libgcj-class-loader-patch
Patch28: libgcj-fix-resource-constructor-patch
Patch29: libgcj-signal-handler-patch
Patch30: libgcj-eintr-patch
# Patch31: gcj-remove-bytecode-gimplifier-patch
# Patch32: libgcj-pr-11737-patch
# Patch33: libgcj-pr-11779-patch
# Patch34: gcc-fixes-since-20030801-snapshot-patch
Patch35: libgcj-eclipse-runtime-patch
# Patch36: gcc-disable-out-of-ssa-cleanups-patch
# Patch37: gcc-fix-edge-insertion-for-try-catch-patch
# Patch38: gcc-replace-null-exprs-with-nops-patch
# Patch39: gcj-disable-tree-ssa-patch
Patch40: boehm-gc-use-mmap-patch
Patch41: libgcj-canonical-file-patch
Patch42: gcj-byte-compiler-localvars-patch
Patch43: libgcj-namingmanager-patch
Patch44: mudflap-pragma-patch
Patch45: libgcj-sql-timestamp-date-patch
Patch46: libgcj-sql-timestamp-nanos-patch
Patch47: boehm-gc-execute-permission-patch
Patch48: gcj-no-sibcall-patch
Patch49: libgcj-runtime-exec-patch
Patch50: libgcj-toolexec-hack-patch
Patch51: mudflap-unreg3-patch
Patch52: mudflap-specs-patch
Patch53: mudflap-header-patch

%description
The gcc-ssa package contains a snapshot of the GNU Compiler Collection,
with tree-ssa and mudflap support for the C and C++ languages.

%package -n libgcc-ssa
Summary: GCC version 3.0 shared support library.
Group: System Environment/Libraries

%description -n libgcc-ssa
Some GCC version 3.0 and later compiled libraries and/or binaries
need this shared support library.

%package -n libmudflap
Summary: GCC mudflap shared support library
Group: System Environment/Libraries

%description -n libmudflap
This package contains GCC shared support library which is needed
for mudflap support.

%package -n libmudflap-devel
Summary: GCC mudflap support
Group: Development/Libraries
Requires: libmudflap = %{version}-%{release}

%description -n libmudflap-devel
This package contains headers and static libraries for building
mudflap-instrumented programs.

%package -n gcc-c++-ssa
Summary: C++ support for gcc.
Group: Development/Languages
Requires: gcc-ssa = %{version}-%{release}
Requires: libstdc++-ssa = %{version}
Requires: libstdc++-ssa-devel = %{version}

%description -n gcc-c++-ssa
This package adds C++ support to the GNU C compiler version 3.0.
It includes support for most of the current C++ specification,
including templates and exception handling.

%package -n libstdc++-ssa
Summary: GNU Standard C++ Library version 3.
Group: System Environment/Libraries

%description -n libstdc++-ssa
The libstdc++ package contains a rewritten standard compliant GCC Standard
C++ Library version 3.0.

%package -n libstdc++-ssa-devel
Summary: Header files and libraries for C++ development.
Group: Development/Libraries
Requires: libstdc++-ssa = %{version}-%{release}

%description -n libstdc++-ssa-devel
This is the GNU implementation of the standard C++ libraries. This
package includes the header files and libraries needed for C++
development. This includes rewritten implementation of STL.

%package -n gcc-objc-ssa
Summary: Objective C support for gcc version 3.
Group: Development/Languages
Requires: gcc-ssa = %{version}-%{release}
Requires: gcc-objc-ssa >= 2.96-94

%description -n gcc-objc-ssa
gcc-objc provides Objective C support for the GNU C compiler version 3.0.
Mainly used on systems running NeXTSTEP, Objective C is an
object-oriented derivative of the C language.

%package -n libobjc-ssa
Summary: Objective-C runtime
Group: System Environment/Libraries

%description -n libobjc-ssa
This package contains Objective-C shared library which is needed to run
Objective-C dynamically linked programs.

%package -n gcc-g77-ssa
Summary: Fortran 77 support for gcc version 3.
Group: Development/Languages
Requires: gcc-ssa = %{version}-%{release}

%description -n gcc-g77-ssa
The gcc-g77 package provides support for compiling Fortran 77
programs with the GNU gcc compiler version 3.0.

%package -n gcc-java-ssa
Summary: Java support for gcc version 3.
Group: Development/Languages
Requires: gcc-ssa = %{version}-%{release}
Requires: libgcj-ssa >= %{version}
Requires: libgcj-ssa-devel >= %{version}

%description -n gcc-java-ssa
This package adds support for compiling Java(tm) programs and
bytecode into native code. To use this you will also need the libgcj-ssa and
libgcj-devel packages.

%package -n libgcj-ssa
Summary: Java runtime library for gcc.
Group: System Environment/Libraries
Requires: zip >= 2.1
Prereq: /sbin/install-info

%description -n libgcj-ssa
The Java runtime library. You will need this package to run your Java
programs compiled using the gcc version 3 Java compiler (gcj-ssa).

%package -n libgcj-ssa-devel
Summary: Libraries for Java development using gcc version 3.
Group: Development/Languages
Requires: zip >= 2.1, libgcj-ssa = %{version}

%description -n libgcj-ssa-devel
The Java static libraries and C header files. You will need this
package to compile your Java programs using the gcc version 3
Java compiler (gcj-ssa).

%prep
%setup -q -n gcc
# %patch09 -p0 
%patch10 -p0 
%patch11 -p0 
%patch12 -p0 
%patch13 -p0 
%patch20 -p0 
%patch21 -p0 
%patch22 -p0 
%patch23 -p0 
%patch24 -p0 
%patch25 -p0 
%patch27 -p0
%patch28 -p0
%patch29 -p0
%patch30 -p0
# %patch31 -p0
# %patch32 -p0
# %patch33 -p0
# %patch34 -p0
%patch35 -p0
# %patch36 -p0
# %patch37 -p0
# %patch38 -p0
# %patch39 -p0
%patch40 -p0
%patch41 -p0
%patch42 -p0
%patch43 -p0
%patch44 -p0
%patch45 -p0
%patch46 -p0
%patch47 -p0
%patch48 -p0
%patch49 -p0
%patch50 -p0

# Update to a more modern libmudflap
rm -rf libmudflap
%setup -q -T -D -a 1 -n gcc
%patch51 -p0 
%patch52 -p0 
%patch53 -p0 

perl -pi -e 's/\(merged .*\)/\(Red Hat Linux Rawhide %{version}-%{gcc_release}\)/' gcc/version.c
perl -pi -e 's/^const char bug_report_url.*$/const char bug_report_url[] = "<URL:http:\/\/bugzilla.redhat.com\/bugzilla\/>";/' gcc/version.c

./contrib/gcc_update --touch

%build
rm -fr obj-%{_target_platform}
mkdir obj-%{_target_platform}
cd obj-%{_target_platform}

CC=gcc
OPT_FLAGS=`echo $RPM_OPT_FLAGS|sed -e 's/-fno-rtti//g' -e 's/-fno-exceptions//g'`

# We're building the host tools with a compiler that doesn't
# understand -mtune.  The version of gcc we're building will warn if
# you use -mcpu, though, and if we use that with the target libraries,
# configure will get confused and we'll get problems at runtime as a
# result.  So we have to pass different flags to the target libraries.
TARG_FLAGS=`echo $OPT_FLAGS | sed -e 's/-mcpu/-mtune/'`

CC="$CC" CFLAGS="$OPT_FLAGS" CXXFLAGS="$OPT_FLAGS" XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
	../configure --prefix=%{_prefix} --mandir=%{_mandir} --infodir=%{_infodir} \
	--libdir=%{ssa_lib} \
	--host=%{_target_platform} \
	--with-gxx-include-dir=%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/c++ \
	--enable-languages=c,c++,java,objc,f77 \
	--enable-shared --enable-threads=posix \
	--with-system-zlib --enable-__cxa_atexit \
	--disable-multilib


# if RPM_BUILD_NCPUS unset, set it
if [ -z "$RPM_BUILD_NCPUS" ] ; then
  if [ -x /usr/bin/getconf ] ; then
    RPM_BUILD_NCPUS=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $RPM_BUILD_NCPUS -eq 0 ]; then
      RPM_BUILD_NCPUS=1
    fi
  else
    RPM_BUILD_NCPUS=1
  fi
fi

RPM_BUILD_NCPUS=1
make -j$RPM_BUILD_NCPUS CFLAGS_FOR_TARGET="$TARG_FLAGS" CXXFLAGS_FOR_TARGET="$TARG_FLAGS" GCJFLAGS="$TARG_FLAGS"
#make -j$RPM_BUILD_NCPUS bootstrap-lean
#make -j$RPM_BUILD_NCPUS bootstrap

# run the tests.
# rpm seems to terminate when make -k check fails.
# make -i check

# Copy various doc files here and there
cd ..
mkdir -p rpm.doc/g77 rpm.doc/objc
mkdir -p rpm.doc/boehm-gc rpm.doc/fastjar rpm.doc/libffi rpm.doc/libjava

(cd gcc/f; for i in ChangeLog*; do
	cp -p $i ../../rpm.doc/g77/$i.f
done)
(cd libf2c; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/g77/$i.libf2c
done)
(cd gcc/objc; for i in README*; do
	cp -p $i ../../rpm.doc/objc/$i.objc
done)
(cd libobjc; for i in README*; do
	cp -p $i ../rpm.doc/objc/$i.libobjc
done)
(cd boehm-gc; for i in ChangeLog*; do
	cp -p $i ../rpm.doc/boehm-gc/$i.gc
done)
(cd fastjar; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/fastjar/$i.fastjar
done)
(cd libffi; for i in ChangeLog* README* LICENSE; do
	cp -p $i ../rpm.doc/libffi/$i.libffi
done)
(cd libjava; for i in ChangeLog* README*; do
	cp -p $i ../rpm.doc/libjava/$i.libjava
done)

%install
set +e
rm -fr $RPM_BUILD_ROOT

cd obj-%{_target_platform}
TARGET_PLATFORM=%{_target_platform}

make prefix=$RPM_BUILD_ROOT%{_prefix} mandir=$RPM_BUILD_ROOT%{_mandir} \
  infodir=$RPM_BUILD_ROOT%{_infodir} libdir=$RPM_BUILD_ROOT%{ssa_lib} \
  gxx_include_dir=$RPM_BUILD_ROOT%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/c++ install

FULLPATH=$(dirname $RPM_BUILD_ROOT%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/cc1)

# Don't strip the executables; this is beta code after all
# file $RPM_BUILD_ROOT/%{_prefix}/bin/* | grep ELF | cut -d':' -f1 | xargs strip || :
# strip $FULLPATH/{cc1,cc1obj,cc1plus,f771,jc1,jvgenmain}

# Rename the executables
for exec in gcc gcov g++ g77 gcj gcjh jcf-dump jv-scan gij jar grepjar rmic rmiregistry jv-convert addr2name.awk
do
   mv $RPM_BUILD_ROOT%{_prefix}/bin/$exec $RPM_BUILD_ROOT%{_prefix}/bin/${exec}-ssa
done

# This hack ensures that libraries are actually in .../ssa and not in
# /lib64/lib64.
if test -d $RPM_BUILD_ROOT/lib64/lib64; then
  mv $RPM_BUILD_ROOT/lib64/lib64/* $RPM_BUILD_ROOT/%{ssa_lib}
  rmdir $RPM_BUILD_ROOT/lib64/lib64
fi

# Collect static libraries under lib/gcc-lib/..../
for lib in libgcj libstdc++ libsupc++ libobjc libg2c libfrtbegin
do
   mv -f $RPM_BUILD_ROOT/%{ssa_lib}/${lib}.*a $FULLPATH/
done
for lib in libmudflap libmudflapth
do
   mv -f $RPM_BUILD_ROOT/%{ssa_lib}/${lib}.*a $FULLPATH/
done


mv $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/

# Collect some headers under lib/gcc-lib/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/{java,javax,gnu} $FULLPATH/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/gcj/* $FULLPATH/include/gcj/
# mv -f $RPM_BUILD_ROOT%{_prefix}/include/gc*.h $FULLPATH/include/
mv -f $RPM_BUILD_ROOT%{_prefix}/include/j*.h $FULLPATH/include/

mv -f $RPM_BUILD_ROOT%{_prefix}/include/mf-runtime.h $FULLPATH/include/

# Update specs files to point at new place
perl -pi -e 's@lib:@lib: -rpath %{ssa_lib} -L %{ssa_lib}@;s/-lgcjgc//g;s/-lzgcj//g' \
	$RPM_BUILD_ROOT%{ssa_lib}/libgcj.spec
perl -pi -e 's@%\{L\*\}@-rpath %{ssa_lib} -L%{ssa_lib} %{L*}@' $FULLPATH/specs


%clean
rm -rf $RPM_BUILD_ROOT

%post -n libgcc-ssa
/sbin/ldconfig -n %{ssa_lib}

%postun -n libgcc-ssa
/sbin/ldconfig -n %{ssa_lib}

%post -n libstdc++-ssa
/sbin/ldconfig -n %{ssa_lib}

%postun -n libstdc++-ssa
/sbin/ldconfig -n %{ssa_lib}

%post -n libobjc-ssa
/sbin/ldconfig -n %{ssa_lib}

%postun -n libobjc-ssa
/sbin/ldconfig -n %{ssa_lib}

%post -n libgcj-ssa
/sbin/ldconfig -n %{ssa_lib}

%postun -n libgcj-ssa
/sbin/ldconfig -n %{ssa_lib}

%files
%defattr(-,root,root)
%{_prefix}/bin/gcc-ssa
%{_prefix}/bin/gcov-ssa
%dir %{ssa_lib}/gcc-lib
%dir %{ssa_lib}/gcc-lib/%{_target_platform}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include
#%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/bits
#%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/linux
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/stddef.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/stdarg.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/varargs.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/float.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/limits.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/stdbool.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/iso646.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/syslimits.h
%ifarch ia64
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/ia64intrin.h
%endif
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/README
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/cc1
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/collect2
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/crt*.o
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libgcc.a
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libgcc_eh.a
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libgcov.a
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/specs
%doc gcc/README* gcc/*ChangeLog*

%files -n libgcc-ssa
%defattr(-,root,root)
/%{ssa_lib}/libgcc_s.so*

%files -n libmudflap
%defattr(-,root,root)
/%{ssa_lib}/libmudflap.so*
/%{ssa_lib}/libmudflapth.so*

%files -n libmudflap-devel
%defattr(-,root,root)
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/mf-runtime.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libmudflap.*a
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libmudflapth.*a

%files -n gcc-c++-ssa
%defattr(-,root,root)
%{_prefix}/bin/g++-ssa
%dir %{ssa_lib}/gcc-lib
%dir %{ssa_lib}/gcc-lib/%{_target_platform}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/cc1plus
%doc gcc/cp/ChangeLog*

%files -n libstdc++-ssa
%defattr(-,root,root)
%{ssa_lib}/libstdc++.so*

%files -n libstdc++-ssa-devel
%defattr(-,root,root)
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/c++
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libstdc++.*a
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libsupc++.*a
%doc libstdc++-v3/ChangeLog* libstdc++-v3/README*

%files -n gcc-objc-ssa
%defattr(-,root,root)
%dir %{ssa_lib}/gcc-lib
%dir %{ssa_lib}/gcc-lib/%{_target_platform}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/objc
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/cc1obj
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libobjc.*a
%{ssa_lib}/libobjc.so*
%doc rpm.doc/objc/*
%doc libobjc/THREADS* libobjc/ChangeLog

%files -n gcc-g77-ssa
%defattr(-,root,root)
%{_prefix}/bin/g77-ssa
%dir %{ssa_lib}/gcc-lib
%dir %{ssa_lib}/gcc-lib/%{_target_platform}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/f771
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libg2c.*a
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libfrtbegin.*a
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/g2c.h
%{ssa_lib}/libg2c.so*
%doc gcc/f/README rpm.doc/g77/*

%files -n gcc-java-ssa
%defattr(-,root,root)
%{_prefix}/bin/gcj-ssa
%{_prefix}/bin/gcjh-ssa
%{_prefix}/bin/jcf-dump-ssa
%{_prefix}/bin/jv-scan-ssa
%dir %{ssa_lib}/gcc-lib
%dir %{ssa_lib}/gcc-lib/%{_target_platform}
%dir %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/jc1
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/jvgenmain
%doc gcc/java/ChangeLog*

%files -n libgcj-ssa
%defattr(-,root,root)
%{_prefix}/bin/jv-convert-ssa
%{_prefix}/bin/gij-ssa
%{_prefix}/bin/jar-ssa
%{_prefix}/bin/grepjar-ssa
%{_prefix}/bin/rmic-ssa
%{_prefix}/bin/rmiregistry-ssa
%{ssa_lib}/libgcj.so*
%{ssa_lib}/security
%{_prefix}/share/java

%files -n libgcj-ssa-devel
%defattr(-,root,root)
%{_prefix}/bin/addr2name.awk-ssa
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/libgcj.*a
%{ssa_lib}/libgcj.spec
# %{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/gc*.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/j*.h
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/java
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/javax
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/gnu
%{ssa_lib}/gcc-lib/%{_target_platform}/%{gcc_version}/include/gcj
%doc rpm.doc/boehm-gc/* rpm.doc/fastjar/* rpm.doc/libffi/*
%doc rpm.doc/libjava/*

%changelog
* Tue Aug  3 2004 Frank Ch. Eigler <fche@redhat.com> 0.20030801.48
- Added several mudflap patches, wholesale libmudflap replacement.

* Wed Mar  3 2004 Tom Tromey <tromey@redhat.com> 0.20030801.47
- Added libgcj-toolexec-hack-patch

* Tue Feb  3 2004 Tom Tromey <tromey@redhat.com> 0.20030801.46
- Added libgcj-runtime-exec-patch

* Thu Jan  8 2004 Andrew Haley <aph@redhat.com> 0.20030801.45
- Add gcj-no-sibcall-patch.
- Add boehm-gc-execute-permission-patch.
- Revert previous patch: Use "solib" rather than "gcjlib"

* Thu Dec 11 2003 Tom Tromey <tromey@redhat.com> 0.20030801.44
- Use "gcjlib" rather than "solib"
 
* Mon Nov 10 2003 Gary Benson <gbenson@redhat.com> 0.20030801.43
- Added sql-timestamp patches to fix Oracle JDBC driver bug.

* Mon Nov 03 2003 Frank Ch. Eigler <fche@redhat.com> 0.20030801.42
- Use #pragma redefine_extname to hook libmudflap functions
- Package up libmudflapth* files.

* Thu Sep 18 2003 Tom Tromey <tromey@redhat.com> 0.20030801.41
- Added naming manager patch; fixes Tomcat bug

* Wed Sep 17 2003 Tom Tromey <tromey@redhat.com> 0.20030801.40
- Updated libgcj-optional-pr-9125-patch to fix eclipse bug

* Fri Sep 12 2003 Andrew Haley <aph@redhat.com> 0.20030801.39
- Add gcj-byte-compiler-localvars-patch.

* Thu Sep 11 2003 Tom Tromey <tromey@redhat.com> 0.20030801.38
- Added canonical file patch

* Mon Sep 08 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.37
- Fix C++ include directories
- Configure compiler with checking enabled

* Fri Sep 05 2003 Tom Tromey <tromey@redhat.com> 0.20030801.36
- GC uses mmap instead of brk

* Thu Aug 28 2003 Bill Nottingham <notting@redhat.com> 0.20030801.35
- Fix https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=102467

* Thu Aug 14 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.34
- Add libgcj-fix-resource-constructor-patch

* Wed Aug 13 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.33
- Go back to 20030617 snapshot

* Wed Aug 13 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.32
- Disable tree-ssa when compiling Java programs

* Mon Aug 11 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.31
- Add fixes since 20030801 snapshot
- Remove duplicate patch gcc-fix-edge-insertion-patch
- Disable out of SSA cleanup pass to workaround a C++ codegen problem
- Fix edge insertion for try/catch constructs
- Fix gimplification of NULL expressions

* Fri Aug  8 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.30
- Disable SSA optimizers for C++ code in libjava
- Fix generation of version string

* Fri Aug  8 2003 Andrew Haley <aph@redhat.com> 0.20030801.29
- Insert patch for eclipse runtime

* Wed Aug 06 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.28
- Import patch to fix edge insertion case for Java

* Tue Aug 05 2003 Tom Tromey <tromey@redhat.com> 0.20030801.27
- Imported patch for gcj PRs 11737 and 11779

* Fri Aug 01 2003 Diego Novillo <dnovillo@redhat.com> 0.20030801.26
- Update to 20030801 branch snapshot
- Add patch to remove some mainline changes to libgcj that conflict with
  patches needed for Eclipse (libgcj-reverse-time-patch)
- Remove bytecode gimplifier (gcj-remove-bytecode-gimplifier-patch)
- Remove duplicate libgcj-fix-resource-constructor-patch
- Update libgcj EINTR patch

* Fri Jul 25 2003 Tom Tromey <tromey@redhat.com> 0.20030617.25
- Add patch to fix libgcj handling of EINTR

* Wed Jul  9 2003 Andrew Haley <aph@redhat.com> 0.20030617.24
- Add patch to fix SEGV in signal handler with new kernels.

* Tue Jun 17 2003 Diego Novillo <dnovillo@redhat.com> 0.20030617.23
- Updated to 20030617 branch snapshot
- Removed duplicate patch libgcj-slow-pthread-self-patch
- Removed duplicate patch libgcj-alignment-patch
- Removed duplicate patch libgcj-string-init-patch
- Removed duplicate patch gcc-boehm-ppc-patch
- Removed duplicate patch libgcc-ffi-powerpc-patch
- Removed duplicate patch libgcj-ffi-eh-patch
- Removed duplicate patch boehm-gc-disable-gimple-patch
- Removed duplicate patch libgcj-fix-aliasing-patch
- Removed duplicate patch gcc-fix-volatile-asm-gimplification-patch

* Tue Jun 10 2003 Diego Novillo <dnovillo@redhat.com> 0.20030428.22
- Add Andrew Haley's patch to fix gimplification of volatile __asm__

* Thu Jun 05 2003 Diego Novillo <dnovillo@redhat.com> 0.20030428.21
- Add Andrew Haley's patch to fix resource constructor in java

* Wed Jun 04 2003 Diego Novillo <dnovillo@redhat.com> 0.20030428.20
- Add Andrew Haley's patch to fix aliasing problems in libjava's signal
  handling on AMD64

* Fri May 30 2003 Diego Novillo <dnovillo@redhat.com> 0.20030428.19
- Disable SSA optimizations for libjava and boehm-gc

* Fri May 23 2003 Diego Novillo <dnovillo@redhat.com> 0.20030428.18
- Work around miscompilation of bohem-gc

* Wed Apr 30 2003 Tom Tromey <tromey@redhat.com> 0.20030428.17
- Added jcf-parse gcj patch
- Added libgcj String initialization patch

* Mon Apr 28 2003 Diego Novillo <dnovillo@redhat.com> 0.20030428.16
- Updated to 20030428 branch snapshot
- Removed duplicate Patch13: gcj-pr-10145-patch
- Removed duplicate Patch14: gcj-field-class-init-patch
- Removed duplicate Patch26: libgcj-prefix-patch
- Removed duplicate Patch30: ia64-boehm-gc-patch
- Removed duplicate Patch32: gcc-boehm-phdr-patch

* Wed Apr 23 2003 Tom Tromey <tromey@redhat.com> 0.20030312.15
- Added patch to fix libgcj layout rules

* Mon Apr 21 2003 Graydon Hoare <graydon@redhat.com> 0.20030312.14
- Added a patch to libffi, to fix exception handling in libgcj

* Mon Apr 21 2003 Graydon Hoare <graydon@redhat.com> 0.20030312.13
- Added a patch to libffi, implementing powerpc closures 

* Mon Apr 21 2003 Tom Tromey <tromey@redhat.com> 0.20030312.12
- Added boehm-phdr patch
- Added field-class-init patch
- Added slow-thread-self patch

* Wed Apr 16 2003 Tom Tromey <tromey@redhat.com> 0.20030312.11
- Added class loader patch

* Fri Apr  4 2003 Tom Tromey <tromey@redhat.com> 0.20030312.10
- Added PPC boehm-gc patch

* Thu Apr  3 2003 Tom Tromey <tromey@redhat.com> 0.20030312.9
- Added gcj-pr-10145-patch

* Sat Mar 29 2003 Tom Tromey <tromey@redhat.com> 0.20030312.8
- Use -mtune instead of -mcpu when building target libraries
- New version of assume-exception patch

* Fri Mar 28 2003 Tom Tromey <tromey@redhat.com> 0.20030312.7
- Don't install w3c and xml libraries

* Wed Mar 26 2003 Tom Tromey <tromey@redhat.com>
- Added patch so libgcj will find .security files properly
- Release 6

* Wed Mar 26 2003 Tom Tromey <tromey@tooth.toronto.redhat.com>
- Hack around multilib on x86-64
- Removed some non-rewritten includes

* Thu Mar 20 2003 Frank Ch. Eigler <fche@redhat.com>
- switch to exclusivearch tag; include ppc
- add rth's ia64 boehm-gc patch; not sufficient for full ia64 build
- remove version tweaking of nonexistent gcc/f/version.*

* Wed Mar 19 2003 Tom Tromey <tromey@redhat.com>
- Install w3c and xml gcj libraries and libgcj.so
- Put libraries in /lib/ssa
- Release 3

* Thu Mar 13 2003 Frank Ch. Eigler <fche@redhat.com>
- added gcj/libgcj patches for Eclipse from <tromey@redhat.com>
- fixed x86_64 multilib references (.../lib/... vs .../%{_lib}/...)
- enabled normal gcc garbage collection

* Wed Mar 12 2003 Frank Ch. Eigler <fche@redhat.com>
- updated to 20030312 branch snapshot
- enabled x86_64, but without multilibs

* Mon Mar 03 2003 Frank Ch. Eigler <fche@redhat.com>
- updated to 20030302 branch snapshot
- excluded x86_64 also for now

* Fri Feb 21 2003 Frank Ch. Eigler <fche@redhat.com>
- created package

